"use strict";
let url1="https://transport.data.gouv.fr/gbfs/nancy/station_information.json";
let url2="https://transport.data.gouv.fr/gbfs/nancy/station_status.json";

function convertStampDate(unixtimestamp){
   	 // Cette fonction permet de convertir un "timestamp"
   	 // (voir l'attribut correspondant dans les fichiers JSON)
   	 // en une chaîne de caractères lisible

   	 var months_arr = ['Janvier','Février','Mars','Avril','Mai','Juin','Juillet','Août','Septembre','Octobre','Novembre','Décembre'];
   	 // Convert timestamp to milliseconds:
   	 var date = new Date(unixtimestamp*1000);
   	 // Year:
   	 var year = date.getFullYear();
   	 // Month:
   	 var month = months_arr[date.getMonth()];
   	 // Day:
   	 var day = date.getDate();
   	 // Hours:
   	 var hours = date.getHours();
   	 // Minutes:
   	 var minutes = "0" + date.getMinutes();
   	 // Seconds:
   	 var seconds = "0" + date.getSeconds();
   	 // String for displaying date and time in dd-MM-yyyy h:m:s format:
   	 var fulldate = day+' '+month+' '+year+' - '+hours + ':' + minutes.substr(-2) + ':' + seconds.substr(-2);

   	 return fulldate;
}   



var lat = 48.692054;
var lon = 6.184417;
var map = L.map('map').setView([lat, lon], 11);
L.tileLayer('https://{s}.tile.openstreetmap.fr/osmfr/{z}/{x}/{y}.png').addTo(map);

let markers= new Array();
Promise.all([
  				fetch(url1).then(response => response.json()),
  				fetch(url2).then(response => response.json())
				]).then((data) => {
			
				let data1=data[0];
				let data2=data[1];
				for(let i=0;i<data1.data.stations.length; i++){
				var marker=L.marker([data1.data.stations[i].lat,data1.data.stations[i].lon]);
				map.addLayer(marker);
				markers[i]=[marker];
				}
});

function stationproche() {
	Promise.all([
  fetch(url1).then(response => response.json()),
  fetch(url2).then(response => response.json())
]).then((data) => {

	
	let data1=data[0];
	let data2=data[1];
		
	let stationx = data1.data.stations[0].lat;
	let stationy = data1.data.stations[0].lon;
	
	let latitude = parseFloat(document.getElementById("lati").value);
	let longitude = parseFloat(document.getElementById("long").value);
	
	let coordonnees = 0;
	let coordonneestation = 0;
	let infostationproche="";
	let stationfinale=data1.data.stations[0].station_id;
	let id_final=0;
	let meilleures = document.getElementById("stationproche").innerHTML=data1.data.stations[0].name;
	let markerstation=L.marker([data1.data.stations[0].lat,data1.data.stations[0].lon]);
	let infos="";
	let avert="";
	for (let i = 0; i < data1.data.stations.length; i++) {
		coordonnees = Math.abs(stationx - latitude)**2 + Math.abs(stationy - longitude)**2;
		coordonneestation = Math.abs(data1.data.stations[i].lat - latitude)**2 + Math.abs(data1.data.stations[i].lon - longitude)**2;
		
	
		if(coordonnees > coordonneestation) {
			stationx = data1.data.stations[i].lat;
			stationy = data1.data.stations[i].lon;
			meilleures = document.getElementById("stationproche").innerHTML=data1.data.stations[i].name;
			stationfinale=data1.data.stations[i].station_id;
			id_final=i;
			markerstation=L.marker([data1.data.stations[i].lat,data1.data.stations[i].lon]);
		} 
	}
		infos = data1.data.stations[id_final].name + "<br>";
		infos += "Adresse : " +  data1.data.stations[id_final].address + "<br>";
		infos += "Vélos disponibles : " + data2.data.stations[id_final].num_bikes_available + " <br>";
		infos += "Places disponibles : " + data2.data.stations[id_final].num_docks_available + " <br>";
		infos += "Capacité totale : " + data1.data.stations[id_final].capacity + "<br";
		infos += "Date de dernière mise à jour : " + convertStampDate(data2.last_updated);
		
		markerstation.addTo(map);
		map.flyTo([stationx, stationy], 16);
		markerstation.bindPopup(infos).openPopup();
		for (let i=0; i<data1.data.stations.length; i++){
			if (data2.data.stations[i].num_bikes_available===0){
				avert = "IL N'Y A PLUS DE VÉLO DISPONIBLE ⚠";
			}
			if (data2.data.stations[i].num_docks_available===data1.data.stations[i].capacity){
				avert += "IL N'Y A PLUS DE PLACE DISPONIBLE ⚠";
			}
			document.getElementById("avertissement").innerHTML=avert;
		}
	});	

}
 


	